%concaten_ficros_carbinorgdissous_p2l1.m

%objectif: prog de concatenation des fichiers "ficrosdficcoordpxly_modif" (fichier trame)
                                 %avec "carbone_inorg_dissous_PxLy" (fichier carbone inorganique dissous) 
%FICHIERS LUS:
%fichiers "ficrosdficcoordpxly_modif"  : 
                      %legende + donnes (8 colonnes)
                      %fichier excel, suppression de la legende et enregistrement en .txt
%fichiers "carbone_inorg_dissous_PxLy.xls": 
                  %legende + donnes (24 colonnes)
                  %fichier excel, suppression lgende et enregistrement en .txt

%concatene les deux fichiers par mise en correspondance du n de station et du n de btl
               %n de station = col n2 pour fichier ficros
               %n de station = col n3 pour fichier carbinorgdiss
               %n de btl = col n3 pour fichier ficros
               %n de btl = col n19 pour fichier crbinorgdiss
%attention fichier carb inorg diss: nombre de colonnes varie en fonction du leg considr
%P1L1:24 colonnes
%P2L1:26 col (nstation et nbtl en +)
%P3L1:28 col (nstation, nbtl, NH4 et Si en +)
%XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
%trame
cd D:\pomme\ctdraw\etaloxlp\refdesc\oxygdefexpl\fichiers_rosette_complets\ficros_coord\concaten_ficrosdcoord
load ficrosdficcoordp2l1_modif.txt
%Detail des colonnes:
%col 1=n ligne
%col 2=n station
%col 3=n position btl
%col 4=prof dbars
%col 5=station
%col 6=juldeb
%col 7=latcent
%col 8=longcent
%choix du parametre au sein de la liste du fichier trame rosette
%liste fichier rosette (=trame rosette)=listros
listros={'nligne','nstation','posbtl','prof','station','juldeb','latcent','longcent'};

%fichier donnees pomme web
cd D:\pomme\ctdraw\donnees_pomme_web_NOV_2003\carbone_inorganique_dissous
load carbone_inorg_dissous_P2L1.txt
%choix du n de la colonne (pour le fichier dosage uniquement)
%pour dossier "CID", le fichier dosage est "carbone_inorg_dissous_P1L1.txt"
dosligcol=1;  %n de la colonne 'n de ligne' du fichier dosage
doscruisecol=2;  % n de la colonne 'cruise' du fichier dosage
dosstacol=3;  % n de la colonne 'station' du fichier dosage
dostypecol=4;  % n de la colonne 'type' du fichier dosage
dosdatecol=5; % n de la colonne 'date' dbars du fichier dosage
doslongcol=6; % n de la colonne 'longitude'  du fichier dosage
doslatcol=7; % n de la colonne 'latitude' du fichier dosage
dosbdepthcol=8; % n de la colonne 'B-Depth' du fichier dosage
doscastcol=9; % n de la colonne 'cast' du fichier dosage
dosbottlecol=10;  %n de la colonne 'bottle' du fichier dosage
dosdepthcol=11;  % n de la colonne 'depth' du fichier dosage
dospresscol=12;  % n de la colonne 'pressure' du fichier dosage
dostempcol=13;  % n de la colonne 'temp' du fichier dosage
dossalcol=14; % n de la colonne 'sal' dbars du fichier dosage
dosctcol=15; % n de la colonne 'CT'  du fichier dosage
dosphcol=16; % n de la colonne 'pH' du fichier dosage
dosatcol=17; % n de la colonne 'AT' du fichier dosage
dosfco2col=18; % n de la colonne 'fCO2' du fichier dosage
dosniskcol=19;  % n de la colonne 'niskin' du fichier dosage (niskin1)
dosno2col=20; % n de la colonne 'NO2' dbars du fichier dosage
dosno3col=21; % n de la colonne 'NO3'  du fichier dosage
dospo4col=22; % n de la colonne 'PO4' du fichier dosage
dosniskincol=23; % n de la colonne 'niskin' du fichier dosage (niskin2)
doso2col=24; % n de la colonne 'O2' du fichier dosage


%choix du parametre au sein de la liste du fichier dosage
%liste fichier dosage=listdos
listdos={'LIG','CRUI','STA','TYPE','DATE','LONG','LAT','BDEPTH','CAST','BOTTLE','DEPTH','PRESSURE','TEMP','SAL','CT','PH','AT','FCO2','NISK','NO2','NO3','PO4','NISKIN','O2'};
%XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
cd D:\pomme\ctdraw\etaloxlp\refdesc\oxygdefexpl\fichiers_rosette_complets\ficros_coord\concaten_ficrosdcoord
load ficrosdficcoordp2l1_modif.txt
rostm=ficrosdficcoordp2l1_modif (:,1:8)

textbtl='nligne,nstation,posbtl,prof,station,juldeb,latcent,longcent';
%  affichage des variables par colonne pour controle
nstaros=rostm(:,2);%nstaros= n station trame rosette  
nbtlros=rostm(:,3);%nbtlros= n btl trame rosette  
ntros=length(rostm); %ntros= nbre de lignes trame rosette

%lecture du fichier dosage
cd D:\pomme\ctdraw\donnees_pomme_web_NOV_2003\carbone_inorganique_dissous
load carbone_inorg_dissous_P2L1.txt
ydos=carbone_inorg_dissous_P2L1; %pour commodit
nstados= ydos(:,3); %nstados=n station dosage 
nbtldos=ydos(:,19); %nbtldos=n btl dosage
ntdos= length(ydos); %ntdos= nbre de lignes dosage
%j'ajoute donc 26 colonnes au fichier rostm de dpart, mais je les copie d'abord
roscomb=rostm; %roscomb pour rosette combin
%bidon11= ones(ntros,27)*NaN  ; %je dois donc remplir bidon avec les lignes de ydos.
bidon11= ones(ntros,26)*NaN  ; %je dois donc remplir bidon avec les lignes de ydos.
%RQ: le fait de rajouter 27 colonnes alors qu'il n'y a que 26 colonnes de donnes  insrer permet de crer une col prsence/absence de donnes (cf aussi ligne 116 du prog:  bidon11(ntr,:)=[ydos(indntd,:) 1];  )
%cette col supplmentaire sera supprime par la suite au sein du fichier rsultat excel
%autre solution: on passe deux fois le prog: une fois avec, une fois sans

%Mise en correspondance des fichiers rosette (trame rosette) et dosage. Les deux fichiers doivent avoir le meme nbre de lignes. 
%Postulat: le nbre de lignes du fichier rosette est sup  celui du fichier dosage, par consequent on met en correspondance le fichier dosage 
%Reperage des n de col du n de station de ydos et reperage des n de belle de ydos. Puis les indiquer dans le programme.
disp (' nombre de lignes rosette     nombre de ligne fic dosage ')
disp (   [ntros , ntdos])
nbid=0;

%bl=[ NaN NaN NaN NaN NaN NaN NaN NaN NaN NaN NaN NaN ];
%tabfinal=[];

for ntr=1:ntros;
    %jul1=nstaros(ntr);
    %meilleurdiff=999999;
    %idx=0;
    %for ntr2=2:ntdos;
      %  jul2=nstados(ntr2);
       % if fix(jul1)==fix(jul2);
       %    diff=abs(jul1-jul2);
       %    if diff<meilleurdiff ;
      %          meilleurdiff=diff;
      %          idx=ntr2;
      %      end
      %   end
      %  end
  %  if not(idx==0) ;
  %     tabfinal(ntr,:)=[rostm(ntr,1:12) ydos(idx,1:12)];
  %  else
  %      tabfinal(ntr,:)=[rostm(ntr,1:12) bl];
  %   end
  %end
    
   
%if 1==0    
    
  % indntd=find((nstados)==(nstaros(ntr)));
indntd=find((nstados==nstaros(ntr))&(nbtldos==nbtlros(ntr)));
    if size(indntd,1)==1;
        bidon11(ntr,:)=ydos(indntd,:) ;
        %bidon11(ntr,:)=[ydos(indntd,:) 1]; %cf lignes 76  78
        nbid =nbid+1; %mise en place d'un compteur (pour verification)
    end
    if size (indntd,1)>1; disp('plus qu une ligne avc meme btl et meme station');
        disp('ligne fichier dosage  station'); disp(nstados(indntd(1,1)));disp(indntd);   
    end
    % si indntd est vide je laisse les Nan dans bidon1
 end
 
% if 1==0
 nbid
%bidon11= fichier de mise en correspondance (des fichiers rosette et dosage)
rosdos=bidon11 ;
textdos='LIG,CRUI,STA,TYPE,DATE,LONG,LAT,BDEPTH,CAST,BOTTLE,DEPTH,PRESSURE,TEMP,SAL,CT,PH,AT,FCO2,NISK,NO2,NO3,PO4,NISKIN,O2';

%A EXECUTER SI CORRECT POUR SAUVEGARDE:
cd D:\pomme\ctdraw\etaloxlp\refdesc\oxygdefexpl\fichiers_rosette_complets\ficrosdcoord_donpomweb
textrosimp='nligne,nstation,posbtl,prof,station,juldeb,latcent,longcent (trame), LIG,CRUI,STA,TYPE,DATE,LONG,LAT,BDEPTH,CAST,BOTTLE,DEPTH,PRESSURE,TEMP,SAL,CT,PH,AT,FCO2,NISK,NO2,NO3,PO4,NISKIN,O2';

save  ficros_carbinorgdiss_p2l1    rostm rosdos textdos textbtl textrosimp
%rosimp=[rostm(:,1), rostm(:,2), rostm(:,3), rostm(:,4), rosdos(:,1), rosdos(:,2), rosdos(:,3), rosdos(:,4), rosdos(:,5), rosdos(:,6), rosdos(:,7), rosdos(:,8), rosdos(:,9), rosdos(:,10), rosdos(:,11), rosdos(:,12)];
rosimp=[rostm, rosdos];
save ficros_carbinorgdiss_p2l1.txt rosimp  -ascii
end